CuTimers = {}

CuTimers.Objects = {}

function CuTimers.CreateTimer (interval, repeats, cuFunc, active, description)
	local timer = {}
	timer.interval = interval
	timer.active = active or true
	timer.description = description or "no desc"
	timer.framecount = 0
	timer.framerates = 0
	timer.executions = 0
	--timer.timer = timer
	timer.repeats = repeats
	timer.cuFunc = cuFunc
	
	
	
	
	function timer.Run(elapsed, framerate)
		local framerate = framerate
		if (timer.active) then
			--print("timer ".. timer.description .. " running")
			
			timer.framerates = timer.framerates + framerate		
			timer.framecount = timer.framecount + 1
		
		
		
			if (timer.framecount > ((timer.framerates / timer.framecount)*timer.interval) and ((timer.executions <= timer.repeats) or timer.repeats == -1))  then
				timer.executions = timer.executions + 1 
				timer.cuFunc()
				--print(timer.executions)
				timer.framecount = timer.framecount - ((timer.framerates / timer.framecount)*timer.interval)
				timer.framerates = 0
				
				--timer.framecount = 0
				--print (timer.framecount)
				
			end
			
			if (timer.executions >= timer.repeats and timer.repeats ~= -1) then
				timer.stop()
			end
		end
	end 	
	
	function timer.Stop()
		timer.active = false
		--print("timer ".. timer.description .. " stopped")
	end
	
	
	tinsert(CuTimers.Objects, timer)
	--print("timer ".. timer.description .. " created")
end

function CuTimers.Update(timer, elapsed)
	cfr = GetFramerate()
	
	for i = 1, #CuTimers.Objects, 1 do
		--print(cfr)
		CuTimers.Objects[i].Run(elapsed, cfr)
	end
end


CuTimers.hookFrame = CreateFrame("Frame", nil, UIParent)

CuTimers.hookFrame:SetScript("onUpdate", CuTimers.Update)
